// CFGNode.java
//
// ICS 142 Winter 2004
// Assignment #6
//
// Each node in a ControlFlowGraph is an object that implements this interface.
// Abstractly, a CFGNode is a sequence of Instructions, numbered consecutively
// beginning at 0.


public interface CFGNode
{
	// getInstructionCount() returns the number of instructions in this
	// CFGNode.
	public int getInstructionCount();

	// getInstruction() returns the instruction with the given instruction
	// number.
	public Instruction getInstruction(int instructionNumber);

	// replaceInstruction() takes an instruction number and information about
	// a replacement instruction.  It replaces the old instruction with a new
	// one build out of the parts you provided as parameters.  You may not
	// replace a control-flow instruction (e.g. "cbr" or "jumpI") with a
	// non-control-flow instruction!
	public void replaceInstruction(
		int instructionNumber, int opcode,
		Object source1, Object source2,
		Object target1, Object target2);

	// removeInstruction() removes the instruction with the given instruction
	// number.  This doesn't always remove the instruction; in some cases, the
	// instruction is automatically replaced with a "nop" instead.  Also, you
	// are not permitted to remove the last instruction from a node if it's
	// a condition branch or jump instruction!
	public void removeInstruction(int instructionNumber);
}
