// ControlFlowGraph.java
//
// ICS 142 Winter 2004
// Assignment #6
//
// Each of your optimizer passes will be passed an object of a class that
// implements this interface.  All of the code in the input file will be
// represented as one ControlFlowGraph object.  A control flow graph
// consists of a set of nodes, numbered consecutively, starting at 0.
// The methods here are fairly self-explanatory, with two exceptions:
//
//   * The getSuccessorNodeNumbers() method takes a nodeNumber and gives
//     you back an integer array consisting of all the nodes that the
//     given node points to.  The size of the array will always be exactly
//     the number of outgoing edges that the given node has.
//
//   * The getPredecessorNodeNumbers() method is similar, except it gives
//     back an array of the nodes that point to the given node.
//
// By the way, I said this in the write-up, but it bears repeating: DO NOT
// REMOVE NODE 0 FROM THE CFG!


public interface ControlFlowGraph
{
	public int getNodeCount();
	public CFGNode getNode(int nodeNumber);
	public void removeNode(int nodeNumber);
	public int[] getSuccessorNodeNumbers(int nodeNumber);
	public int[] getPredecessorNodeNumbers(int nodeNumber);
	public void output();
}
