// Driver.java
//
// ICS 142 Winter 2004
// Assignment #6
//
// DO NOT MODIFY THE CONTENTS OF THIS FILE!

import java.util.*;


public class Driver
{
	public static void main(String[] args)
	{
		if (args.length < 2)
		{
			printUsageMessage();
			return;
		}

		try
		{
			ILOCParser p = new ILOCParser(new ILOCScanner(new java.io.FileReader(args[0])));
			ArrayList instructions = (ArrayList) (p.parse().value);

			ArrayList optimizerPasses = new ArrayList();

			for (int i = 1; i < args.length; ++i)
			{
				try
				{
					int optNumber = Integer.parseInt(args[i]);
					optimizerPasses.add(OptimizerPassFactory.createOptimizerPass(optNumber));
				}
				catch (NumberFormatException e)
				{
					printUsageMessage();
					return;
				}
				catch (OptimizerPassFactoryException e)
				{
					System.out.println(e.getMessage());
					return;
				}
			}

			Optimizer o = new Optimizer(instructions, optimizerPasses);

			System.out.println("Original version, before optimization:");
			o.output();

			o.optimize();

			System.out.println();
			System.out.println("Optimized version:");
			o.output();
		}
		catch (java.io.FileNotFoundException e)
		{
			System.out.println("Input file " + args[0] + " not found");
		}
		catch (ParserError e)
		{
			System.out.println(e.getMessage());
			System.out.println("Analysis aborted");
		}
		catch (ScannerError e)
		{
			System.out.println(e.getMessage());
			System.out.println("Analysis aborted");
		}
		catch (Exception e)
		{
			System.out.println("Analysis aborted due to exception:");
			e.printStackTrace();
		}
	}



	public static void printUsageMessage()
	{
		System.out.println("Usage: java Driver input_filename opt1 ...");
	}
}
