// Instruction.java
//
// ICS 142 Winter 2004
// Assignment #6
//
// Each CFGNode contains a sequence of instructions, numbered beginning at 0.
// When you call getInstruction() on a CFGNode, you get an object that
// implements this interface.
//
// I should point a couple of things out here:
//
//  (1) getOpcode() returns an int that is one of the constants defined in
//      the Opcodes class (e.g. Opcode.JUMPI).
//  (2) The operands are stored as Object references.  Registers are stored
//      as strings beginning with the letter "r".  Labels are stored as
//      strings beginning with the letter "L".  Integer constants are stored
//      as Integer objects.  Boolean constants are stored as Boolean objects.


public interface Instruction
{
	public String getLabel();
	public void setLabel(String label);
	public int getOpcode();
	public Object getSourceOperand1();
	public Object getSourceOperand2();
	public Object getTargetOperand1();
	public Object getTargetOperand2();
}
