// Opcodes.java
//
// ICS 142 Winter 2004
// Assignment #6
//
// DO NOT MODIFY THE CONTENTS OF THIS FILE!  PARTS OF THE COMPILED CODE
// DEPEND ON IT REMAINING AS-IS!


public class Opcodes
{
	private static final String[] opcodeNames = { "",
		"add", "addI", "and", "andI", "cbr", "cmp_EQ", "cmp_GE", "cmp_GT",
		"cmp_LE", "cmp_LT", "cmp_NE", "div", "divI", "i2i", "jump", "jumpI",
		"load", "loadAI", "loadAO", "loadI", "lshift", "lshiftI", "mult",
		"multI", "nop", "not", "or", "orI", "rdivI", "rshift", "rshiftI",
		"rsubI", "store", "storeAI", "storeAO", "sub", "subI", "xor", "xorI"
	};


	private static final int[] sourceOperandCounts = { 0,
		2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 2, 1, 0, 0, 1, 2, 2, 1,
		2, 2, 2, 2, 0, 1, 2, 2, 2, 2, 2, 2, 1, 1, 1, 2, 2, 2, 2 };


	private static final int[] targetOperandCounts = { 0,
		1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
		1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1 };


	public static final int ADD = 1;
	public static final int ADDI = 2;
	public static final int AND = 3;
	public static final int ANDI = 4;
	public static final int CBR = 5;
	public static final int CMP_EQ = 6;
	public static final int CMP_GE = 7;
	public static final int CMP_GT = 8;
	public static final int CMP_LE = 9;
	public static final int CMP_LT = 10;
	public static final int CMP_NE = 11;
	public static final int DIV = 12;
	public static final int DIVI = 13;
	public static final int I2I = 14;
	public static final int JUMP = 15;
	public static final int JUMPI = 16;
	public static final int LOAD = 17;
	public static final int LOADAI = 18;
	public static final int LOADAO = 19;
	public static final int LOADI = 20;
	public static final int LSHIFT = 21;
	public static final int LSHIFTI = 22;
	public static final int MULT = 23;
	public static final int MULTI = 24;
	public static final int NOP = 25;
	public static final int NOT = 26;
	public static final int OR = 27;
	public static final int ORI = 28;
	public static final int RDIVI = 29;
	public static final int RSHIFT = 30;
	public static final int RSHIFTI = 31;
	public static final int RSUBI = 32;
	public static final int STORE = 33;
	public static final int STOREAI = 34;
	public static final int STOREAO = 35;
	public static final int SUB = 36;
	public static final int SUBI = 37;
	public static final int XOR = 38;
	public static final int XORI = 39;


	public static String getOpcodeName(int opcode)
	{
		if (opcode < 1 || opcode > 39)
		{
			return "";
		}
		else
		{
			return opcodeNames[opcode];
		}
	}


	public static boolean isNormalOpcode(int opcode)
	{
		return !isControlFlowOpcode(opcode) && opcode != NOP;
	}


	public static boolean isControlFlowOpcode(int opcode)
	{
		return opcode == CBR || opcode == JUMP || opcode == JUMPI;
	}
	
	
	public static int getSourceOperandCount(int opcode)
	{
		return sourceOperandCounts[opcode];
	}
	
	
	public static int getTargetOperandCount(int opcode)
	{
		return targetOperandCounts[opcode];
	}
}
