// OptimizerPassFactory.java
//
// ICS 142 Winter 2004
// Assignment #6
//
// Here's how the rest of the program knows what optimization techniques are
// supported.  Naturally, if you want us to be able to grade your program,
// you won't change the meaning of the first three optimization numbers.
// But if you were to add additional optimization techniques, this is where
// you would add them.


public class OptimizerPassFactory
{
	public static OptimizerPass createOptimizerPass(int optNumber)
	{
		switch (optNumber)
		{
		case 1:
			return new LocalAlgebraicSimplification();

		case 2:
			return new LocalConstantPropagationAndFolding();

		case 3:
			return new UnreachableBlockElimination();

		default:
			throw new OptimizerPassFactoryException("Unrecognized optimization #: " + optNumber);
		}
	}
}
